SystemOrganization addCategory: #'GMF-Facade'!

Object subclass: #Facade
	instanceVariableNames: ''
	classVariableNames: 'UMLElements dataModel'
	poolDictionaries: ''
	category: 'GMF-Facade'!

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:12'!
addAssociation: xDataClass
	self checkNill.
	dataModel addAssociation: xDataClass! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:12'!
addClass: xDataClass
	self checkNill.
	dataModel addClass: xDataClass! !

!Facade class methodsFor: 'private' stamp: 'RostislavNovak 11/28/2013 20:31'!
checkNill
	dataModel ifNil: [ dataModel := DataModel new ].! !

!Facade class methodsFor: 'clear' stamp: 'RostislavNovak 11/25/2013 21:10'!
clearData
	dataModel := DataModel new.! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/28/2013 20:32'!
generate
	| data |
	self checkNill.
	UMLElements := TransformToUML dataToTransform: dataModel asMetaModel modelElements.
	UMLElements transformAll.
	data := DataForGenerator UMLModel: UMLElements transformedElements.
	UMLElements dataForGenerator: data dataForGenerator.
	CodeGenerator setDataWithAll: UMLElements dataForGenerator.
	^ true! !

!Facade class methodsFor: 'accessing' stamp: 'volosmat 1/1/2014 20:25'!
getAssociation: xName start: aName end: bName
	self checkNill.
	^ dataModel associations
		detect: [ :e | 
			xName = e metaModelClass name &
			aName = ((e metaModelClass) start) name &
			bName = e metaModelClass end name ]
		ifNone: [  ]! !

!Facade class methodsFor: 'accessing' stamp: 'volosmat 12/20/2013 23:31'!
getAssociations
	self checkNill.
	^ dataModel associations! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:18'!
getClass: xName
	self checkNill.
	^ dataModel elements detect:  [ :e | xName = e metaModelClass name ]  ifNone: [].! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/28/2013 20:32'!
getClasses
	self checkNill.
	^ dataModel elements! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/28/2013 20:32'!
getDiagram
	self checkNill.
	^dataModel! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/25/2013 21:26'!
loadDiagram! !

!Facade class methodsFor: 'removing' stamp: 'volosmat 1/2/2014 14:04'!
removeAssociation: xGMFGACover
	self checkNill.
	xGMFGACover metaModelClass start removeAssociation: xGMFGACover metaModelClass name.
	xGMFGACover metaModelClass end removeAssociation: xGMFGACover metaModelClass name.
	dataModel removeAssociation: xGMFGACover! !

!Facade class methodsFor: 'removing' stamp: 'volosmat 12/21/2013 00:08'!
removeClass: xGMFGACover 
	self checkNill.
	self removeClassAssociations: xGMFGACover.
	dataModel removeClass: xGMFGACover! !

!Facade class methodsFor: 'private' stamp: 'volosmat 12/21/2013 00:22'!
removeClassAssociations: xGMFGACover 
	self getAssociations
		do: [:each | (each metaModelClass start name = xGMFGACover metaModelClass name) | (each metaModelClass end name = xGMFGACover metaModelClass name)
				ifTrue: [
					each class = GMFGAInheritance
						ifTrue: [each metaModelClass end removeParent: xGMFGACover metaModelClass name].
					Facade removeAssociation: each]]! !

!Facade class methodsFor: 'removing' stamp: 'volosmat 12/31/2013 10:50'!
removeClassInheritance: xGMFGACover 
	self removeStartInheritance: xGMFGACover.
	self removeEndInheritance: xGMFGACover ! !

!Facade class methodsFor: 'removing' stamp: 'volosmat 12/31/2013 10:49'!
removeEndInheritance: xGMFGACover 
	self getAssociations
		do: [:each | each metaModelClass end name = xGMFGACover metaModelClass name & (each class = GMFGAInheritance) 
				ifTrue: [each metaModelClass end removeParent: xGMFGACover metaModelClass name.
					Facade removeAssociation: each]]! !

!Facade class methodsFor: 'removing' stamp: 'volosmat 12/31/2013 10:49'!
removeStartInheritance: xGMFGACover 
	self getAssociations
		do: [:each | each metaModelClass start name = xGMFGACover metaModelClass name & (each class = GMFGAInheritance) 
				ifTrue: [each metaModelClass end removeParent: xGMFGACover metaModelClass name.
					Facade removeAssociation: each]]! !

!Facade class methodsFor: 'accessing' stamp: 'volosmat 12/20/2013 15:00'!
saveDiagram
	dataModel saveFile.! !
